//+------------------------------------------------------------------+
//|                                                        #_arb.mq5 |
//|                                                            Graff |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Graff"
#property link      "https://login.mql5.com/ru/users/Graff"
#property version   "1.00"
#property indicator_separate_window
//#property indicator_chart_window

#define max_buffers 20

#property indicator_buffers max_buffers
#property indicator_plots   max_buffers
//+------------------------------------------------------------------+
//| Draw buffers store struct
//+------------------------------------------------------------------+
struct buffers
  {
   double            buff[];
   string            symbol;
  };

buffers buffer[];
//+------------------------------------------------------------------+
//| Formulas for current symbol
//+------------------------------------------------------------------+
struct formulas
  {
   string            symbol1;
   string            symbol2;
   string            action;// umnogenie or delenie
  };

formulas formula[];
input int count=500;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   Comment("");
//=== EU formula generator
// loading all currencies from market watch window to array
   uint scount=SymbolsTotal(true);
   string symbols[];
   ArrayResize(symbols,scount);
   for(uint i=0;i<scount;i++)
     {
      symbols[i]=SymbolName(i,true);
     }
   for(uint i=0;i<scount;i++)
     {
      string s1=symbols[i];
      if(s1==Symbol()) continue;
      double s1_close=SymbolInfoDouble(s1,SYMBOL_BID);
      for(uint j=0;j<scount;j++)
        {
         string s2=symbols[j];
         if(s1==s2 || s2==Symbol()) continue;
         double s2_close=SymbolInfoDouble(s2,SYMBOL_BID);
         double umnogenie=s1_close*s2_close;
         double delenie=s1_close/s2_close;

         if(umnogenie>=(SymbolInfoDouble(Symbol(),SYMBOL_BID)-0.02) && umnogenie<=(SymbolInfoDouble(Symbol(),SYMBOL_BID)+0.02) && !CheckDuplications(s1,s2,formula))
            AddFormula(s1,s2,"*",formula);

         if(delenie>=(SymbolInfoDouble(Symbol(),SYMBOL_BID)-0.02) && delenie<=(SymbolInfoDouble(Symbol(),SYMBOL_BID)+0.02))
            AddFormula(s1,s2,"/",formula);
        }
     }
//--- indicator buffers mapping
   uint fc=ArraySize(formula);
   ArrayResize(buffer,fc+1);
   InitBuffer(0,buffer[0].buff,Symbol());
   for(uint i=0;i<fc;i++)
     {
      if(i<max_buffers) InitBuffer(i+1,buffer[i+1].buff,formula[i].symbol1+formula[i].action+formula[i].symbol2);
      Print(formula[i].symbol1,formula[i].action,formula[i].symbol2);
     }
   //Print("init complete");
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Adds formula to struct
//+------------------------------------------------------------------+
void AddFormula(string s1,string s2,string act,formulas &f[])
  {
   static uint fcount;
   fcount++;
   ArrayResize(formula,fcount);
   formula[fcount-1].symbol1=s1;
   formula[fcount-1].symbol2=s2;
   formula[fcount-1].action=act;
  }
//+------------------------------------------------------------------+
//| checking duplicating multiplying formulas
//+------------------------------------------------------------------+
bool CheckDuplications(string s1,string s2,formulas &f[])
  {
   uint fccount=ArraySize(f);
   for(uint i=0;i<fccount;i++)
     {
      if(f[i].symbol1==s2 && f[i].symbol2==s1 && f[i].action=="*") return(true);
     }
   return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void InitBuffer(uint Id,double &Array[],string Name)
  {
//---  web-
   color iColor[129]=
     {
      clrGreen,clrSlateGray,clrOlive,
      clrTeal,clrNavy,clrPurple,clrMaroon,clrIndigo,clrMidnightBlue,
      clrBlue,clrSaddleBrown,clrForestGreen,clrOliveDrab,
      clrSeaGreen,clrGoldenrod,clrSlateBlue,clrSienna,clrMediumBlue,
      clrBrown,clrTurquoise,clrDimGray,clrLightSeaGreen,clrViolet,
      clrFireBrick,clrMediumVioletRed,clrMediumSeaGreen,clrChocolate,clrCrimson,
      clrSteelBlue,clrGoldenrod,clrMediumSpringGreen,clrLawnGreen,clrCadetBlue,
      clrOrchid,clrYellowGreen,clrLimeGreen,clrOrangeRed,clrOrange,
      clrOrange,clrGold,clrYellow,clrChartreuse,clrLime,clrSpringGreen,
      clrAqua,clrDeepSkyBlue,clrBlue,clrMagenta,clrRed,clrGray,
      clrSlateGray,clrPeru,clrBlueViolet,clrLightSlateGray,clrDeepPink,
      clrMediumTurquoise,clrDodgerBlue,clrTurquoise,clrRoyalBlue,clrSlateBlue,
      clrKhaki,clrIndianRed,clrMediumOrchid,clrGreenYellow,clrMediumAquamarine,
      clrSeaGreen,clrTomato,clrRosyBrown,clrOrchid,clrMediumPurple,
      clrPaleVioletRed,clrCoral,clrCornflowerBlue,clrGray,clrSandyBrown,
      clrMediumSlateBlue,clrTan,clrSalmon,clrBurlyWood,clrHotPink,
      clrSalmon,clrViolet,clrLightCoral,clrSkyBlue,clrLightSalmon,
      clrPlum,clrKhaki,clrLightGreen,clrAquamarine,clrSilver,
      clrLightSkyBlue,clrLightSteelBlue,clrLightBlue,clrPaleGreen,clrThistle,
      clrPowderBlue,clrPaleGoldenrod,clrPaleTurquoise,clrLightGray,clrWheat,
      clrNavajoWhite,clrMoccasin,clrLightPink,clrGainsboro,clrPeachPuff,
      clrPink,clrBisque,clrLightGoldenrod,clrBlanchedAlmond,clrLemonChiffon,
      clrBeige,clrAntiqueWhite,clrPapayaWhip,clrCornsilk,clrLightYellow,
      clrLightCyan,clrLinen,clrLavender,clrMistyRose,clrOldLace,
      clrWhiteSmoke,clrSeashell,clrIvory,clrHoneydew,clrAliceBlue,
      clrLavenderBlush,clrMintCream,clrSnow,clrWhite
     };
   uint width=1;
   if(StringFind(Symbol(),Name,0)>=0) width=3;
   PlotIndexSetInteger(Id,PLOT_LINE_WIDTH,width);
   PlotIndexSetInteger(Id,PLOT_DRAW_TYPE,DRAW_LINE);
//PlotIndexSetInteger(Id,PLOT_DRAW_TYPE,DRAW_HISTOGRAM);
   PlotIndexSetInteger(Id,PLOT_LINE_COLOR,iColor[Id]);
//--- set AsSeries(dependes from input parameter)
   ArraySetAsSeries(Array,true);
//--- indicator buffers mapping
   SetIndexBuffer(Id,Array,INDICATOR_DATA);
   PlotIndexSetString(Id,PLOT_LABEL,Name);
//ArrayInitialize(Array,0);
   PlotIndexSetInteger(Id,PLOT_DRAW_BEGIN,TerminalInfoInteger(TERMINAL_MAXBARS)-count);
   ArrayInitialize(Array,EMPTY_VALUE);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
//--- check if all data calculated
   if(rates_total<1) return(0);
//--- we can copy not all data
   int to_copy;
   if(prev_calculated>rates_total || prev_calculated<=0)
     {
      to_copy=count;
     }
   else
     {
      to_copy=rates_total-prev_calculated+1;
      //--- last value is always copied
     }
   //Comment(to_copy," ",ArraySize(buffer));
   GetClose(Symbol(),Period(),to_copy,buffer[0].buff);// real buffer

   uint fcount=ArraySize(formula);
   for(uint fc=0;fc<fcount;fc++)// drawing evry formula
     {
      double s1[],s2[];
      GetClose(formula[fc].symbol1,Period(),to_copy,s1);
      GetClose(formula[fc].symbol2,Period(),to_copy,s2);
      if(formula[fc].action=="*")
        {
         for(int i=to_copy-1; i>=0; i--)
           {
            buffer[fc+1].buff[i]=s1[i]*s2[i];
           }
        }
      else
        {
         for(int i=to_copy-1; i>=0; i--)
           {
            buffer[fc+1].buff[i]=s1[i]/s2[i];
           }
        }
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
int GetClose(string smb,ENUM_TIMEFRAMES tf,int copy_count,double &out[])
  {
   int ret=CopyClose(smb,tf,0,copy_count,out);
   ArraySetAsSeries(out,true);
//Print(smb," ",ret," ",GetLastError());
   return(ret);
  }
//+------------------------------------------------------------------+
